/********************************************
* sock.c - Main socket routines
*
* CVS $Id: sock.c,v 1.5 2001/01/18 14:21:14 wcampbel Exp $
********************************************/

#include "oper.h"

fd_set readfds, nullfds;

int Connect()
{
        struct hostent *hp;
        struct sockaddr_in sa;
        int s;
	char* host = me.uplink;
	int port = me.port;
	struct in_addr * in;

        if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0)
                return (-1);

	if (me.use_vhost) {
		bzero(&sa, sizeof(sa));
		sa.sin_family = AF_INET;
		if ((hp = gethostbyname (me.vhost)) == NULL) {
			return (-1);
		}
		in = (struct in_addr *) (hp->h_addr_list[0]);
		sa.sin_addr.s_addr = in->s_addr;
		sa.sin_port = 0;
		if (bind(s, (struct sockaddr *) &sa, sizeof(sa)) < 0) {
			close(s);
			return (-1);
		}
	}

        if ((hp = gethostbyname (host)) == NULL) {
                return (-1);
        }

        bzero(&sa, sizeof(sa));
        sa.sin_family = AF_INET;
        sa.sin_port = htons (port);
    bcopy(hp->h_addr, (char *) &sa.sin_addr, hp->h_length);

        if (connect (s, (struct sockaddr *) &sa, sizeof (sa)) < 0) {
                close (s);
                return (-1);
        }

	return s;
}

void ListenLoop()
{
        int i, j, SelectResult;
        struct timeval TimeOut;
        char c;
        char buf[BUFSIZE];

        while (1) {
                memset(buf, '\0', BUFSIZE);
                FD_ZERO(&readfds);
                TimeOut.tv_sec = 500;
                TimeOut.tv_usec = 0L;
                FD_SET(servsock, &readfds);
        if ((SelectResult = select(FD_SETSIZE, &readfds, &nullfds, &nullfds,
                        &TimeOut)) > 0) {
                        for (j = 0; j < BUFSIZE; j++) {
                                if (FD_ISSET(servsock, &readfds)) {
                                        i = read(servsock, &c, 1);
                                        if (i !=0) {
                                                buf[j] = c;
                                                if ((c == '\n') || (c == '\r'))
						{
                                                        Parse(buf);
                                                        break;
                                                }
                                        } else
                                                return;
                                } else
                                        break;
                        }
                } else {
                        if (SelectResult == 0) {
                                log("Lost connection to server.");
                                return;
                        }
                }
        }
}

